<?php
namespace JsonApi\Ext\AtomicOperations;

use Psr\Http\Message\ServerRequestFactoryInterface;
use Psr\Http\Message\ServerRequestInterface;
use Psr\Http\Message\StreamFactoryInterface;

abstract class Operation
{
    abstract public function getMethod(): string;

    /**
     * @var mixed
     */
    protected $data;

    /**
     * @var string
     */
    protected $href;

    final public function __construct(string $href, array $data = null)
    {
        $this->href = $href;
        $this->data = $data;
    }

    public function getHref(): string
    {
        return $this->href;
    }

    public function getData()
    {
        return $this->data;
    }
}
